// Control context menu
function objDownloadWith(pref)
{
	///////////// Private variables /////////////
	var preference = pref;
	var bundle;

	///////////// Public Methods /////////////
	this.init = function() {
		bundle = document.getElementById("downloadwithbundle");
		document.getElementById("contentAreaContextMenu").addEventListener("popupshowing",downloadWith.initMenu,false);
	}

	this.commanded = function(e,menu) {
		var t = e.target;
		if (t.id != "downloadwith-invalide-url") {
			// load url
			var baseurl = t.getAttribute("url");
			// Execute application
			var application = preference.getApplication(t.id);
			var label = application[preference.LABEL];
			var command = application[preference.COMMAND];
			var arguments = application[preference.ARGS];
      
			// replace URL 
			var strArgs = arguments.replace(/\[URL\]/, baseurl);
			dwUtil.execCommand(command,strArgs);
		}
		if(e.button==1) menu.hidePopup();  
	}

	this.initMenu = function() {
		var cm = gContextMenu;
		document.getElementById("context-downloadwith").hidden = !cm.onLink;
	}

	this.clearMenu = function(menu) {
		while(menu.hasChildNodes()) menu.removeChild(menu.lastChild);
	}

	this.getLink = function() {
		var elem = document.popupNode;
		while(elem) {
			if(elem instanceof Components.interfaces.nsIDOMHTMLAnchorElement && elem.href)
				return elem.href;
			elem = elem.parentNode;
		}
		return null;
	}

	this.buildMenu = function(menu) {
		var url = this.getLink();
		if(!url) return;
		if(/^(ht|f)tp:\/\//.test(url)) {
			for (var application = preference.getFirstApplication();application != null;application = preference.getNextApplication()) {
				if (application[preference.LABEL] != null && application[preference.LABEL] != "" ) this.addItemApplication(menu,url,application[preference.IDENT],application[preference.LABEL]);
			}
		} else { this.addItemInvalide(menu); }
	}
    
	this.addItemInvalide = function(menu) {
		var menuitem = document.createElement("menuitem");
		menuitem.setAttribute("label",bundle.getString("invalideURL"));
		menuitem.setAttribute("id","downloadwith-invalide-url");
		menu.appendChild(menuitem);
	}
  
	this.addItemApplication = function(menu,url,id,label) {
		var menuitem = document.createElement("menuitem");
		if (preference.showContextMenuURL())  { menuitem.setAttribute("label",label  + " " + url); }
		else { menuitem.setAttribute("label",label); }
		menuitem.setAttribute("url",url);
		menuitem.setAttribute("id",id);
		menu.appendChild(menuitem);
	}
}